#include "breuk.h"
#include "gcd.h"
#include <iostream>

int Breuk::total(0);

Breuk::Breuk(int t, int n): t_(t), n_(n) {
if (n==0) { // we don't know about exceptions yet, otherwise
  // we'd throw one here
  std::cerr << __PRETTY_FUNCTION__ << ": noemer 0" << std::endl;
  exit(1);
  }
simplify();
++total;
}

Breuk::Breuk(const Breuk& b): t_(b.t_), n_(b.n_) {
++total;
}

Breuk::~Breuk() {
// Trace t(__PRETTY_FUNCTION__);
--total;
}

std::ostream&
operator<<(std::ostream& os, const Breuk& b) {
os << b.t_ << "/" << b.n_;
return os;
}

Breuk
Breuk::add(Breuk b) { 
return Breuk(t_ * b.n_ + b.t_ * n_, n_ * b.n_);
}

Breuk
Breuk::multiply(Breuk b) { 
return Breuk(t_ * b.t_ , n_ * b.n_);
}

void
Breuk::simplify() { 
int d(gcd(t_,n_));
t_ /= d;
n_ /= d;
}
