// The proof of this algorithm is not difficult. Suppose a and b are
// the numbers whose GCD has to be determined. And suppose the
// remainder of the division of a by b is c. Therefore a = qb + c
// where q is the quotient of the division. Now any common divisor of
// a and b also divides c (since c can be written as c = a - qb);
// similarly, any common divisor of b and c will also divide a. Thus
// the greatest common divisor of a and b is the same as the greatest
// common divisor of b and c. Therefore it is enough if we continue
// the process with the numbers b and c. Since c is smaller in
// absolute value than b, we will reach c = 0 after finitely many
// steps.
#include	<iostream>
#include	"gcd.h"

int
gcd(int u,int v) { // use Euclid's algorithm to compute the greatest common divisor of u,v
// cout << "gcd(" << u << "," << v << ")" << endl;
if (v==0)
  return u;
else
  return gcd(v,u%v);
}
